//+------------------------------------------------------------------+
//|                                                       .mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property version   "1.00"             //     High    
                                      //          

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Magenta
#property indicator_color2 DodgerBlue
#property indicator_color3 Yellow
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_level1 0
//--- input parameters
extern int       PERIOD = 15;
//--- buffers
double buf_up1[], buf_dn1[],buf_sr1[];
double  ema_k0, ema_k1;
int    work_period;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  IndicatorShortName(StringConcatenate(
    " (", PERIOD, ")"));
  IndicatorDigits(Digits);
   SetIndexBuffer(0,buf_sr1);
   SetIndexEmptyValue(0, -1);
   SetIndexLabel(0, "SR VOLUME");
   SetIndexBuffer(1,buf_dn1);
   SetIndexEmptyValue(1, -1);
   SetIndexLabel(1, "DN");
   SetIndexBuffer(2,buf_up1);      
   SetIndexEmptyValue(2, -1);  
   SetIndexLabel(2, "UP");      
   ema_k0 = 2.0 / (PERIOD + 1);
   ema_k1 = 1.0 - ema_k0;  
   work_period = Bars - PERIOD - 2;
   return(0);
   }
   int start() { 
   int    i, j, left = Bars - IndicatorCounted() - 1;
   double u, d, sr;  
   for(i = left; i >= 0; i--) {
    if(i > work_period) {
      buf_up1[i] = -1;
      buf_dn1[i] = -1;
      buf_sr1[i] = -1;
    } else if(i == work_period) {
      buf_up1[i] = 0;
      buf_dn1[i] = 0;
      buf_sr1[i] = 0;
    for(j = Bars - 1; j >= i; j--) {
        calc(j, u, d, sr);      
      buf_up1[i] +=  u  * Volume[j];
      buf_dn1[i] +=   d * Volume[j] ;
      buf_sr1[i] += (u-d) * Volume[j] ;
    }      
      buf_up1[i] /= PERIOD;
      buf_dn1[i] /= PERIOD;
      buf_sr1[i] /= PERIOD;
    } else {
      calc(i, u, d, sr);      
      buf_up1[i] = buf_up1[i + 1] * ema_k1 +  u   * Volume[i]  * ema_k0;
      buf_dn1[i] = buf_dn1[i + 1] * ema_k1 +   d  * Volume[i]  * ema_k0;
      buf_sr1[i] = buf_sr1[i + 1]* ema_k1 + (u-d) * Volume[i]  * ema_k0;
    }}         
     return(0); }   
   // --
   void calc(int bar, double &up1, double &dn1,double &sr1) {
     if(High[bar] == Low[bar]) {
    up1 = 0;dn1 = 0;sr1 = 0;    
    return; }      
     double range = High[bar] - Low[bar];
     double path  =  (Close[bar]- Low[bar]+ 0.707*(Close[bar]-Low[bar]))/2;
     double zum = (range -path)/2 ;
    if(Close[bar] > Open[bar]) {
     dn1 = 1 - (zum + path)/ range ;
     up1 = 1 - dn1;
     sr1 = up1 - dn1;     
  } else {
     up1 = 1 - (zum + path)/ range ;
     dn1 = 1 - up1;
     sr1 = up1 - dn1;
    return; } } 
//+------------------------------------------------------------------+
